#-----------------------------------------------------------------------------
# Group mirror
# by Ockham, 9/2/05
# Copyright (c) 2005 David G Drumright
#-----------------------------------------------------------------------------

from Tkinter import *
import string
import poser
scene = poser.Scene()
SelFig=scene.CurrentFigure()
SelActor=scene.CurrentActor()
try:
    Geom=SelActor.Geometry()
except:
    raise "Selected actor doesn't have a mesh."

#-----------------------------------------------------------------------------

def ReplaceLbyR(Given):
   UpperGiven=string.upper(Given)
   ReturnList=[]

   # Generate all possible switcheroos, and try them.  The arg is the original
   # part name.

   # If the given name has LEFT anywhere in it, we give back a list
   # consisting of (1) the same name (2) the name with LEFT replaced by RIGHT
   # and (3) the name with LEFT replaced by R.

   # If no LEFT, we check for any L.

   # If the given name has L anywhere in it, we give back a list
   # consisting of (1) the same name (2) the name with L replaced by RIGHT
   # and (3) the name with L replaced by R.

   # Most of these replacements will be useless; it's up to the calling routine
   # to check their existence.

   # Look for left:
   if string.count(UpperGiven,'LEFT'):
       # Really only three possibilities here.
       if string.count(Given,'Left'):
           ReturnList.append(string.replace(Given,'Left','Right'))
           ReturnList.append(string.replace(Given,'Left','R'))
       elif string.count(Given,'LEFT'):
           ReturnList.append(string.replace(Given,'LEFT','RIGHT'))
           ReturnList.append(string.replace(Given,'LEFT','R'))
       elif string.count(Given,'left'):
           ReturnList.append(string.replace(Given,'left','right'))
           ReturnList.append(string.replace(Given,'left','r'))
   elif string.count(UpperGiven,'L'):
       # Replace each occurrence separately. Most of these will be stupid.
       for i in range(len(Given)):
           if Given[i]=='l':
               NewGiven=Given[:i]+'r'+Given[(i+1):] # make a copy
               ReturnList.append(NewGiven)
           if Given[i]=='L':
               NewGiven=Given[:i]+'R'+Given[(i+1):] # make a copy
               ReturnList.append(NewGiven)

   return ReturnList

#-----------------------------------------------------------------------------
def ReplaceRbyL(Given):
   UpperGiven=string.upper(Given)
   ReturnList=[]

   # Trying a different approach.  Generate all possible switcheroos, and
   # try them.  The args are the original morph name and an IncludeSame flag.
   # IncludeSame should only be TRUE when using an opposite-side part, where the
   # most likely case is that the swapper is same MT name.
   # On a midline part, set it FALSE so we don't just hit the original MT.

   # If the given name has LEFT anywhere in it, we give back a list
   # consisting of (1) the same name (2) the name with LEFT replaced by RIGHT
   # and (3) the name with LEFT replaced by R.

   # If no LEFT, we check for any L.

   # If the given name has L anywhere in it, we give back a list
   # consisting of (1) the same name (2) the name with L replaced by RIGHT
   # and (3) the name with L replaced by R.

   # Most of these replacements will be useless; it's up to the calling routine
   # to check their existence.

   # Look for left:
   if string.count(UpperGiven,'RIGHT'):
       # Really only three possibilities here.
       if string.count(Given,'Right'):
           ReturnList.append(string.replace(Given,'Right','Left'))
           ReturnList.append(string.replace(Given,'Right','L'))
       elif string.count(Given,'RIGHT'):
           ReturnList.append(string.replace(Given,'RIGHT','LEFT'))
           ReturnList.append(string.replace(Given,'RIGHT','L'))
       elif string.count(Given,'right'):
           ReturnList.append(string.replace(Given,'right','left'))
           ReturnList.append(string.replace(Given,'right','l'))
   elif string.count(UpperGiven,'R'):
       # Replace each occurrence separately. Most of these will be stupid.
       for i in range(len(Given)):
           if Given[i]=='r':
               NewGiven=Given[:i]+'l'+Given[(i+1):] # make a copy
               ReturnList.append(NewGiven)
           if Given[i]=='R':
               NewGiven=Given[:i]+'L'+Given[(i+1):] # make a copy
               ReturnList.append(NewGiven)

   return ReturnList

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("Group mirror")

        self.StatusEntry = Entry(self.master,width=40)
        self.StatusEntry.grid(row=0,column=0,columnspan=3)
        self.StatusEntry.insert(0,"Highlight groups to symmetrize, hit go.")

        # Lists
        self.ListScroll = Scrollbar(self.master, orient=VERTICAL)
        self.ListScroll.grid( row=2, column=0,sticky=N+S+E)
        self.List = Listbox(self.master, height=5, selectmode=MULTIPLE,yscrollcommand = self.ListScroll.set,exportselection=0)
        self.List.grid( row=2, column=1)
        # Set the scrollbar to work
        self.ListScroll["command"] = self.List.yview

        # Go/nogo buttons.
        self.buttonGo = Button(self.master, text="Midline", command=self.HandleGoSame)
        self.buttonGo.grid(row=3, column=0)
        self.buttonGo = Button(self.master, text="Opposite", command=self.HandleGoOpp)
        self.buttonGo.grid(row=3, column=1)

        self.buttonCancel = Button(self.master, text="Cancel", command=self.HandleCancel)
        self.buttonCancel.grid(row=3, column=2)

        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)
        # Fill list with groups
        for Gname in Geom.Groups():
            self.List.insert(END,Gname)


    # - - - - - - - - - - - - - - - - - -

    def ShowStatus(self,S): # Just saving repetition
        self.StatusEntry.delete(0,END)
        self.StatusEntry.insert(0,S)
        self.StatusEntry.update_idletasks()

    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene: scene.ProcessSomeEvents(1)
        root.lift()
        root.after(100, self.Update)

    # - - - - - - - - - - - - - - - - - -

    def HandleGoSame(self):
        Del=0.0001
        Geom=SelActor.Geometry()
        SetList = Geom.Sets()

        Sels=self.List.curselection()
        Gps=[]
        if not Sels:
            self.ShowStatus("Must select some groups.")
            return
        else:
            for i in Sels:
                Gps.append(self.List.get(int(i)))

        for Gname in Gps:
            self.ShowStatus("Working on group %s" % Gname)
            SymmFacets=[] # fresh for each group.
            for F in range(Geom.NumPolygons()):
                if F in SymmFacets: continue # Don't use the opps we already found!
                P=Geom.Polygon(F)
                if not P.InGroup(Gname): continue # Only in this group

                First = P.Start()
                Last = First + P.NumVertices()
                aX=0.0
                aY=0.0
                aZ=0.0
                Count=0.0
                for V in SetList[First:Last]: # This is a list of vertex indexes in the poly
                    SymVert = Geom.Vertex(V) # Get the vert obj
                    aX=aX+SymVert.X()
                    aY=aY+SymVert.Y()
                    aZ=aZ+SymVert.Z()
                    Count=Count+1.0
                aX=aX/Count
                aY=aY/Count
                aZ=aZ/Count
                # This is center of facet.
                # Try to locate the nearest OTHER facet to the opp of this on X
                for Op in range(Geom.NumPolygons()):
                    if Op == F: continue
                    P=Geom.Polygon(Op)
                    First = P.Start()
                    Last = First + P.NumVertices()
                    oX=0.0
                    oY=0.0
                    oZ=0.0
                    Count=0.0
                    for V in SetList[First:Last]: # This is a list of vertex indexes in the poly
                        SymVert = Geom.Vertex(V) # Get the vert obj
                        oX=oX+SymVert.X()
                        oY=oY+SymVert.Y()
                        oZ=oZ+SymVert.Z()
                        Count=Count+1.0
                    oX=-oX/Count # Negative
                    oY=oY/Count
                    oZ=oZ/Count
                    if abs(oX-aX) < Del:
                        if abs(oY-aY) < Del:
                            if abs(oZ-aZ) < Del:
                                SymmFacets.append(Op)  # Hold the index
            # After settling the SymmFacets for this group:
            for F in SymmFacets:
                P=Geom.Polygon(F)
                P.IncludeInGroup(Gname)
            self.ShowStatus("done with group")

    # - - - - - - - - - - - - - - - - - -

    def HandleGoOpp(self):
        Del=0.0001

        # Assume you've followed the readme, which tells you to select the
        # 'new' side, which should have a group of the same name.
        # Try to locate the opposite:
        # Note: Sel here means the currently selected part; Opp means the part on opp side.
        SelName=SelActor.Name()
        OppList=ReplaceLbyR(SelName)
        if not OppList:
            OppList=ReplaceRbyL(SelName)
        if not OppList:
            self.ShowStatus("Can't find opposite body part!")
            return
        # Try the names:
        OppActor=None
        for OppName in OppList:
            OppActor=SelFig.Actor(OppName)
            if OppActor: break

        if not OppActor:
            self.ShowStatus("Can't find opposite body part %s!" % OppName)
            return
        SelGeom=SelActor.Geometry()
        SelSetList = SelGeom.Sets()
        OppGeom=OppActor.Geometry()
        OppSetList = OppGeom.Sets()

        Sels=self.List.curselection()
        Gps=[]
        if not Sels:
            self.ShowStatus("Must select some groups.")
            return
        else:
            for i in Sels:
                Gps.append(self.List.get(int(i)))

        for Gname in Gps:
            self.ShowStatus("Working on group %s" % Gname)
            # Check to see that both have the desired group
            Good=0
            for TryName in SelGeom.Groups():
                if TryName==Gname:
                    Good=Good+1
                    break
            for TryName in OppGeom.Groups():
                if TryName==Gname:
                    Good=Good+1
                    break
            if Good < 2:
                self.ShowStatus("Group %s isn't on both sides." % Gname)
                return
            # Assume Same is the 'blank' one.
            SelFacets=[]
            OppFacets=[] # fresh for each group.
            # The group should be 'complete' on the Opp side, so we look there as our source.
            for F in range(OppGeom.NumPolygons()): # Opp is source
                P=OppGeom.Polygon(F)
                if not P.InGroup(Gname): continue # Only in this group

                First = P.Start()
                Last = First + P.NumVertices()
                aX=0.0
                aY=0.0
                aZ=0.0
                Count=0.0
                for V in OppSetList[First:Last]: # This is a list of vertex indexes in the poly
                    OppVert = OppGeom.Vertex(V) # Get the vert obj
                    aX=aX+OppVert.X()
                    aY=aY+OppVert.Y()
                    aZ=aZ+OppVert.Z()
                    Count=Count+1.0
                aX=aX/Count
                aY=aY/Count
                aZ=aZ/Count
                # This is center of facet.
                # Now try to locate the nearest facet to the opp of this on X, in the Sel side.
                for S in range(SelGeom.NumPolygons()):
                    P=SelGeom.Polygon(S)
                    First = P.Start()
                    Last = First + P.NumVertices()
                    oX=0.0
                    oY=0.0
                    oZ=0.0
                    Count=0.0
                    for V in SelSetList[First:Last]: # This is a list of vertex indexes in the poly
                        SelVert = SelGeom.Vertex(V) # Get the vert obj
                        oX=oX+SelVert.X()
                        oY=oY+SelVert.Y()
                        oZ=oZ+SelVert.Z()
                        Count=Count+1.0
                    oX=-oX/Count # Negative
                    oY=oY/Count
                    oZ=oZ/Count
                    if abs(oX-aX) < Del:
                        if abs(oY-aY) < Del:
                            if abs(oZ-aZ) < Del:
                                SelFacets.append(S)  # Hold the index

            # After locating the facets that need to be set, put them on the Sel side.
            for F in SelFacets:
                P=SelGeom.Polygon(F)
                P.IncludeInGroup(Gname)
            self.ShowStatus("done with group")

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

    # - - - - - - - - - - - - - - - - - -
#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
